<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final String root = request.getContextPath();
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	
	Integer[] pools = Values.getInt(request.getParameterValues("pools"));
	
	int libPlateId = Values.getInt(request.getParameter("bioplate"));
	BioPlate libPlate = libPlateId == 0 ? null : BioPlate.getById(dc, libPlateId);
	String view = Values.getString(request.getParameter("view"), "list");

	String title;
	if (libPlate != null)
	{
		title = "Lab protocol for pooling "+ HTML.encodeTags(libPlate.getName()) + " - " + view;
	}
	else
	{
		title = "Lab protocol for pooling - " + view;
	}
	
%>
<base:page id="protocol" type="iframe" favicon="<%=home+"/images/flowcell.png"%>" title="<%=title%>">
<base:head
	scripts="~../reggie-2.js,~pools.js,~plate.js,~pool_protocol.js" 
	styles="~../css/reggie-2.css,~../css/printable.css,~../css/plate.css"
	>
	<style>
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		margin-bottom: 1em;
		border-collapse: collapse;
	}

	table.protocolheader > tbody > tr
	{
		vertical-align: top;
		height: 1.25em;
	}

	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1em;
		background-color: #F0F0F0;
		padding: 2px;
	}
	
	table.protocolheader > tbody > tr > td
	{
		text-align: left;
		font-size: 1em;
		padding: 2px;
	}

	.pool-section
	{
		page-break-inside: avoid;
	}

	table.poolheader
	{
		margin-top: 1em;
		width: 100%;
		border: 1px solid #000000;
		border-bottom: 0px;
		border-collapse: collapse;
	}

	table.poolheader > tbody > tr
	{
		height: 1.25em;
	}

	table.poolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 1.25em;
		padding: 1px;
	}
	
	.listview
	{
		width: 100%;
		font-size: 85%;
		border-collapse: collapse;
		border: 1px solid #000000;
	}
	
	.listview tr.oddcol
	{
		background-color: #F0F0F0;
	}
	
	.listview thead
	{
		border: 1px solid #000000;
		background-color: #F0F0F0;
	}
	
	.listview th
	{
		border-left: 1px solid #000000;
	}
	
	.listview td
	{
		border-left: 1px solid #000000;
		border-top: 1px dotted #666666;
		vertical-align: middle;
		padding: 2px;
	}
	
	.listview .summary
	{
		border-top: 1px solid #000000;
	}
	
	.listview .col-num
	{
		width: 1.75em;
		text-align: center;
		font-size: 125%;
		font-weight: bold;
		vertical-align: top;
	}
	
	.listview .lib
	{
		width: 15em;
		text-align: center;
	}
	
	.listview .empty .lib
	{
		font-style: italic;
		color: #666666;
		text-align: center;
	}
	
	.listview .workplate
	{
	
		width: <%=libPlate==null ? "14em" : "7em"%>;
		text-align: center;
	}
	
	.listview .pool
	{
		width: 7em;
		text-align: center;
	}
	
	.listview .remain, .listview .molarity
	{
		width: 4.5em;
		padding-right: 0.5em;
		text-align: right;
	}

	.listview .volume
	{
		width: 3.5em;
		padding-right: 0.5em;
		text-align: right;
		color: #C80000;
	}
	
	.listview .eb
	{
		width: 3.5em;
		padding-right: 0.5em;
		text-align: right;
		color: #0000C8;
	}
	
	.listview .remarks
	{
		vertical-align: top;
		padding-left: 0.25em;
	}
	
	.mix-remark .volume, .mix-remark .eb
	{
		padding: 0;
		text-align: inherit;
		width: inherit;
		font-weight: bold;
	}

	
	
	/* Divide the 12 wells across the full page */
	#plateview .well
	{
		width: 8.2%;
		max-width: 8.2%;
		min-width: 8.2%;
		padding: 4px;
	}
	
	#plateview .well:hover
	{
		padding: 3px;
	}
	
	#plateview .rowheader
	{
		width: 2em;
	}
	
	#plateview .lib
	{
		font-weight: bold;
		margin-bottom: 0.25em;
	}
	#plateview .volume
	{
		color: #C80000;
	}
	#plateview .eb
	{
		color: #0000C8;
		float: right;
	}
	
	#plateview .remarks
	{
		color: #C80000;
		font-style: italic;
	}
	
	#plateview .mix-remark
	{
		display: none;
	}
	
	.pool-eb
	{
		color: #0000C8;
	}
	
	#pool-row th
	{
		border-top: 0;
		border-bottom: 1px solid #808080;
		vertical-align: top;
		padding: 0;
	}
	
	#plateview .pool-data
	{
		font-weight: normal;
	}
	#plateview .comments
	{
		font-style: italic;
	}
	
	
	</style>
</base:head>
<base:body>
	
	<div class="paper <%=view.equals("list") ? "" : "landscape"%>">
	
	<form name="reggie" id="wizard">
	
	<div id="page-data" class="datacontainer"
		data-libplate="<%=libPlateId%>"
		data-pools="<%=Values.getString(Arrays.asList(pools), ",", true)%>"
		data-view="<%=view%>"
	></div>
	
	<div id="wizard-status"></div>
	
	<div id="all-protocol" style="display: none;">
	<div id="print-instructions" class="noprint fullwidth">
		<base:button id="print-button" image="<%=home+"/images/print.png"%>" title="Print&hellip;" />
		<span id="printNote">
		<b>Note!</b> 
		<%
		if (view.equals("list"))
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>portrait</i>. To fit everything on a single page, scale down to <i>60-70%</i>.
			<%
		}
		else
		{
			%>
			For better printing reduce margins to about <i>5mm</i> and set page orientation
			to <i>landscape</i>. The recommended scale is <i>100%</i>.
			<%
		}
		%>
		</span>
		<br clear="all">
	</div>
	
	<h1>Lab protocol for library pooling <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

	<table style="width: 100%;" class="protocolheader">
	<tr style="border-bottom: 1px solid #000000;">
		<th style="width: 15%;">Library plate</th>
		<td style="width: 30%; border-right: 1px solid #000000;"><%=libPlate == null ? "Multiple" : HTML.encodeTags(libPlate.getName())%></td>
		<th style="width: 15%;"></th>
		<th style="width: 20%;">Date</th>
		<th style="width: 20%;">Operator</th>
	</tr>
	<tr>
		<td rowspan="1" colspan="2" style="width: 50%; border-right: 1px solid #000000;"><%=libPlate != null ? HTML.niceFormat(libPlate.getDescription()) : ""%></td>
		<td style="border-right: 1px solid #000000;">Pooling</td>
		<td style="border-right: 1px solid #000000;"></td>
		<td></td>
	</tr>
	</table>

	<%
	if (view.equals("list"))
	{
		for (Integer poolId :pools)
		{
			Extract pool = Extract.getById(dc, poolId);
			%>
			<div id="pool.<%=poolId%>" style="display: none;" class="pool-section">
			<table style="width: 100%;" class="poolheader">
			<tr valign="top">
				<th style="width: 25%;"><%=HTML.encodeTags(pool.getName())%></th>
				<th style="width: 75%; border-left: 1px solid #000000;">Comments:</th>
			</tr>
			<tr valign="top">
				<td style="width: 25%;"><span id="molarity.<%=poolId%>"></span></td>
				<td style="border-left: 1px solid #000000;"><%=HTML.niceFormat(pool.getDescription()) %></td>
			</tr>
			</table>
			<table style="width: 100%;" class="listview" id="listview.<%=poolId%>">
			<thead>
				<tr class="toprow">
					<th class="lib"></th>
					<th>Remain</th>
					<th>DNA</th>
					<th class="workplate">Work</th>
					<th>Lib</th>
					<th>EB</th>
					<th></th>
				</tr>
				<tr>
					<th class="lib">Library</th>
					<th>(µl)</th>
					<th>(nM)</th>
					<th class="workplate">plate</th>
					<th>(µl)</th>
					<th>(µl)</th>
					<th>Remarks</th>
				</tr>
			</thead>
			<tbody id="listview.<%=poolId%>.body">
			</tbody>
			<tbody>
				<tr class="summary">
					<td colspan="5" style="text-align: right; font-weight: bold; padding-right: 0.5em; font-size: 120%;">EB volume to add</td>
					<td id="eb-volume.<%=poolId%>" class="eb">eb</td>
					<td></td>
				</tr>
			</tbody>
			</table>
			</div>
			<%
		}
	}
	%>

	<%
	if (view.equals("plate"))
	{
		WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
		WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
		%>
		<table class="plate" style="margin: 0em 0 0 0; width: 100%; display: none;" id="plateview">
		<tr id="pool-row">
			<th colspan="13">&nbsp;</th>
		</tr>
		<tr class="header">
			<th></th>
			<%
			for (int c = 0; c < libPlate.getColumns(); ++c)
			{
				%>
				<th id="col.<%=c%>"><%=colF.format(c)%></th>
				<%
			}
			%>
		</tr>
		<tbody>
		<%
		for (int r = 0; r < libPlate.getRows(); ++r)
		{
			String row = rowF.format(r);
			%>
			<tr class="row-<%=r%>">
				<th id="row.<%=r%>" class="rowheader"><%=row%></th>
				<%
				for (int c = 0; c < libPlate.getColumns(); ++c)
				{
					%>
					<td class="well col-<%=c%>" id="well.<%=r%>.<%=c%>"></td>
					<%
				}
				%>
			</tr>
			<%
		}
		%>
		</tbody>
		</table>
		<div style="margin: 1em;">
			For each pool: <i>Number of libraries</i> • <i>Final molarity</i> • <i>Total volume</i> • <i>EB volume (dynamic mixing only)</i>
		</div>
		<%
	}
	%>
	</div>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>